//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  Red
#property indicator_color2  Red
#property indicator_color3  Gold
#property indicator_color4  DodgerBlue
#property indicator_color5  DodgerBlue
#property indicator_color6  Aqua
#property indicator_width1  1
#property indicator_width2  1
#property indicator_style3  STYLE_DASH 
#property indicator_width4  1
#property indicator_width5  1
#property indicator_style6  STYLE_DASH 

//
//
//
//
//

extern string TimeFrame           = "Current time frame";
extern int    SlowBandsPeriod     = 50;
extern int    SlowBandsMode       = 0;
extern int    SlowBandsPrice      = 0;
extern double SlowBandsDeviations = 1.25;
extern int    FastBandsPeriod     = 20;
extern int    FastBandsMode       = 0;
extern int    FastBandsPrice      = 0;
extern double FastBandsDeviations = 3.25;
extern bool   alertsOn            = true;
extern bool   alertsOnCurrent     = false;
extern bool   alertsMessage       = true;
extern bool   alertsSound         = false;
extern bool   alertsNotify        = true;
extern bool   alertsEmail         = true;
extern string soundFile           = "alert2.wav"; 

//
//
//
//
//

double slowBollUp[];
double slowBollDn[];
double slowBollMd[];
double fastBollUp[];
double fastBollDn[];
double fastBollMd[];
double trend[];
int    timeFrame;

//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,slowBollUp); 
   SetIndexBuffer(1,slowBollDn); 
   SetIndexBuffer(2,slowBollMd); 
   SetIndexBuffer(3,fastBollUp);
   SetIndexBuffer(4,fastBollDn);
   SetIndexBuffer(5,fastBollMd);
   SetIndexBuffer(6,trend);
   
   timeFrame = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" Bandsx2");
   return(0);
  }
  
//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//

int deinit()
{
return(0);
}

//+------------------------------------------------------------------+
//|                             
//+------------------------------------------------------------------+
//
//

int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
            
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--) 
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      double slowStdDev = iStdDev(NULL,timeFrame,SlowBandsPeriod,0,SlowBandsMode,SlowBandsPrice,y); 
      double fastStdDev = iStdDev(NULL,timeFrame,FastBandsPeriod,0,FastBandsMode,FastBandsPrice,y); 

      slowBollMd[i] = iMA(NULL,timeFrame,SlowBandsPeriod,0,SlowBandsMode,SlowBandsPrice,y);
      fastBollMd[i] = iMA(NULL,timeFrame,FastBandsPeriod,0,FastBandsMode,FastBandsPrice,y);
      slowBollUp[i] = slowBollMd[i]+(slowStdDev*SlowBandsDeviations);
      slowBollDn[i] = slowBollMd[i]-(slowStdDev*SlowBandsDeviations);
      fastBollUp[i] = fastBollMd[i]+(fastStdDev*FastBandsDeviations);
      fastBollDn[i] = fastBollMd[i]-(fastStdDev*FastBandsDeviations);
         
         //
         //
         //
         //
         //
         
         trend[i] = 0;
         if (fastBollUp[i]<slowBollUp[i] && fastBollUp[i+1]>slowBollUp[i+1]) trend[i] =-1;
         if (fastBollDn[i]>slowBollDn[i] && fastBollDn[i+1]<slowBollDn[i+1]) trend[i] = 1;
   }
manageAlerts();
return(0);
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar)); 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"Lower Bollinger 20 crossing the Lower bollinger 50 up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"Upper Bollinger 20 crossing the Upper bollinger 50 down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(Period())+" 2 Bands ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," 2 Bands " +" "+message));
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," 2 Bands "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}




